#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <dos.h>
#include <string.h>


main(int argc, char *argv[])
{
int i;
unsigned long data, resource;
unsigned long msb, hsb, nsb, lsb;

FILE *macfile;
FILE *outfile;
FILE *mactype;

char ntypes[9],ftypes[9],buffer[256], fbufr[129],
	 fname[255], fflag, drive[3], dir[129], name[9], ext[8];

char adrv[4],apath[128], aname[9], aext[4], acfg[255];

char macname[64], macnamelen;

char *seaext;

lsb=1;
nsb=256;
hsb=nsb*256;
msb=hsb*256;

fnsplit(argv[0],adrv,apath, aname, aext);
fnmerge(acfg, adrv, apath, aname,".def");



 printf("\n        STRIPSEA v1.01 Copyright (C) 1992 by Ray Arachelian.\n");
 printf("                         All Rights Reserved\n\n");
 printf("                        NEO BBS  718-997-1189\n");
 printf("                       rarachel@ishara.poly.edu\n\n");


if (argc<2 || argc>3)
   { puts ("Usage: STRIPSEA filename {-k}\n");
	 puts ("");
	 puts ("Where filename is the name of the Macintosh SEA file to strip");
	 puts ("if -K param is used, the original sea file will be deleted.");
	 puts ("make sure the STRIPSEA.DEF file is in the same location as this");
	 puts ("program.  If you rename STRIPSEA, you must also rename the .DEF");
	 puts ("file.");
	 delay(1000);
	 return;
   }


macfile=fopen(argv[1],"rb");
if (macfile==NULL)
   {
	printf("ERROR 1: Can't open file `%s'\n",argv[1]);
	return;
   }

fseek(macfile,0,SEEK_SET);
fread(buffer,1,1,macfile);
if (buffer[0]!=0)
   {
	puts("ERROR 2: This is not a MacBin file");
	printf("%hd %hd %hd\n",buffer[0],buffer[1],buffer[2]);
	return;
   }


/*-------- Get SEA name -----------------------------*/
fseek(macfile,1,SEEK_SET);
fread(buffer,1,1,macfile);
fread(macname,60,1,macfile);

macname[buffer[0]+1]=0;
macname[60]=0;

seaext=strstr(macname,".sea");
if (seaext==NULL) seaext=strstr(macname,".SEA");
if (seaext==NULL) seaext=strstr(macname,".Sea");


fseek(macfile,74,SEEK_SET);
fread(buffer,1,1,macfile);
if (buffer[0]!=0)
   {
	puts("ERROR 2B: This is not a MacBin file");
	printf("%hd %hd %hd\n",buffer[0],buffer[1],buffer[2]);
	return;
   }

fseek(macfile,82,SEEK_SET);
fread(buffer,1,1,macfile);
if (buffer[0]!=0)
   {
	puts("ERROR 2C: This is not a MacBin file");
	printf("%hd %hd %hd\n",buffer[0],buffer[1],buffer[2]);
	return;
   }

fseek(macfile,1,SEEK_SET);
fread(buffer,63,1,macfile);

*(buffer+buffer[1]+1)=0;

if (strchr(buffer+1,':')!=NULL)
   {
	puts("ERROR 3: This is not a MacBin file (: in name)");
	return;
   }

if (buffer[0]>63 || buffer[0]<1)
   {
	printf("ERROR 3b: This is not a MacBin file (%d name len)\n",buffer[0]);
	return;
   }


 fseek(macfile,65,SEEK_SET);
 fread(ftypes,8,1,macfile);
 ftypes[8]=0;

 mactype=fopen(acfg,"r");
 if (mactype==NULL)
 {
  printf("Unable to open '%s'  Make sure you place the .def\n",acfg);
  puts("file in the same directory as this program.");
  return;
 }


 while (!feof(mactype))
 {
   fgets(fbufr,128,mactype);
   fbufr[8]=0;

   if (strcmp(fbufr,ftypes)==0)
	  {
	   strncpy(ntypes,fbufr+9,8);
	   fnsplit(argv[1],drive,dir,name,ext);
	   *(fbufr+22)=0;
	   fnmerge(fname,drive,dir,name,fbufr+18);
	   goto okay;
	  }
 }

 puts("This is not a known SEA type.");
 fclose(macfile);
 fclose(mactype);
 return;

okay:
 fclose(mactype);
 fseek(macfile,83,SEEK_SET);
 fread(buffer,4,1,macfile);

 data    =(unsigned long)(((long) (buffer[3])    )   |
			  ((long) (buffer[2]) <<8 )  |
			  ((long) (buffer[1]) <<16)  |
			  ((long) (buffer[0]) <<24)  );



 fseek(macfile,0,SEEK_SET);

 outfile=fopen(fname,"wb");
 if (outfile==NULL)
 {
  printf("Unable to create output file '%s'.\n",fname);
  return;
 }

 printf("Creating %s\n",fname);
 data=(data+128)/128;

   fread(buffer,128,1,macfile);
   memcpy(buffer+65,ntypes,8);
   buffer[87]=0;
   buffer[88]=0;
   buffer[89]=0;
   buffer[90]=0;
   fwrite(buffer,128,1,outfile);


   for (i=0;i<data; i++)
   {
	fread(buffer,128,1,macfile);
	fwrite(buffer,128,1,outfile);
   }


   /*-------- Add .CPT, .SIT, etc. ---------------------*/

   fnsplit(fname,drive,dir,name,ext);

   if (seaext!=NULL)
	strcpy(seaext,ext);
   else
	strcat(macname,ext);

   printf("Adding %s extension to MacFile Name.\n", ext);

   fseek(outfile,1,SEEK_SET);
   macnamelen=strlen(macname);
   fwrite(&macnamelen,1,1,outfile);              /* Write length */
   fwrite(macname,strlen(macname),1,outfile);   /* Write name   */



   fclose(macfile);
   if (fclose(outfile)!=0)
	{
	puts("An error occured while I tried to close this file!");
	return;
	}

   puts("Conversion done.");

   if ((strcmp(argv[2],"-K")==0 || strcmp(argv[2],"-k")==0) && strcmp(fname,argv[1])!=0)
	   {
	unlink(argv[1]);
	puts("Original SEA file deleted.");
	   }


   puts("\n If you've enjoyed this utility, please send $10 to the author:\n");

   puts("                          Ray Arachelian");
   puts("                        48-21 40th Street #1B");
   puts("                        Sunnyside, N.Y. 11104");


 return;
}
