#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <dos.h>
#include <string.h>


main(int argc, char *argv[])
{
int i;
unsigned long data, resource;
unsigned long msb, hsb, nsb, lsb;

FILE *macfile;
FILE *outfile;
FILE *mactype;

char ntypes[9],ftypes[9],buffer[513], fbufr[129],
	 fname[255], fflag, drive[3], dir[129], name[9], ext[8];

char adrv[4],apath[128], aname[9], aext[4], acfg[255];

char macname[64], macnamelen;

char *seaext;

lsb=1;
nsb=256;
hsb=nsb*256;
msb=hsb*256;

fnsplit(argv[0],adrv,apath, aname, aext);
fnmerge(acfg, adrv, apath, aname,".def");



 printf("\n          MBRES v1.01 Copyright (C) 1992 by Ray Arachelian.\n");
 printf("                         All Rights Reserved\n\n");
 printf("                        NEO BBS  718-997-1189\n");
 printf("                       rarachel@ishara.poly.edu\n\n");


if (argc!=3)
   { puts ("Usage: MBRES macname resname\n");
	 puts ("");

	 puts ("Where macname is the MacBin name whose resource fork you wish to");
	 puts ("extract, and resname is the name of the file to extract the");
	 puts ("resources to.");

	 delay(1000);
	 return;
   }


macfile=fopen(argv[1],"rb");
if (macfile==NULL)
   {
	printf("ERROR 1: Can't open file `%s'\n",argv[1]);
	return;
   }

fseek(macfile,0,SEEK_SET);
fread(buffer,1,1,macfile);
if (buffer[0]!=0)
   {
	puts("ERROR 2: This is not a MacBin file");
	printf("%hd %hd %hd\n",buffer[0],buffer[1],buffer[2]);
	return;
   }


/*-------- Get SEA name -----------------------------*/
fseek(macfile,1,SEEK_SET);
fread(buffer,1,1,macfile);
fread(macname,60,1,macfile);

macname[buffer[0]+1]=0;
macname[60]=0;


fseek(macfile,74,SEEK_SET);
fread(buffer,1,1,macfile);
if (buffer[0]!=0)
   {
	puts("ERROR 2B: This is not a MacBin file");
	printf("%hd %hd %hd\n",buffer[0],buffer[1],buffer[2]);
	return;
   }

fseek(macfile,82,SEEK_SET);
fread(buffer,1,1,macfile);
if (buffer[0]!=0)
   {
	puts("ERROR 2C: This is not a MacBin file");
	printf("%hd %hd %hd\n",buffer[0],buffer[1],buffer[2]);
	return;
   }

strcpy(fname,argv[2]);

fseek(macfile,1,SEEK_SET);
fread(buffer,63,1,macfile);

*(buffer+buffer[1]+1)=0;

if (strchr(buffer+1,':')!=NULL)
   {
	puts("ERROR 3: This is not a MacBin file (: in name)");
	return;
   }

if (buffer[0]>63 || buffer[0]<1)
   {
	printf("ERROR 3b: This is not a MacBin file (%d name len)\n",buffer[0]);
	return;
   }


 fseek(macfile,83,SEEK_SET);
 fread(buffer,8,1,macfile);

 data    =(unsigned long)(((long) (buffer[3])    )   |
			  ((long) (buffer[2]) <<8 )  |
			  ((long) (buffer[1]) <<16)  |
			  ((long) (buffer[0]) <<24)  );

 resource=(unsigned long)(((long) (buffer[7])    )   |
			  ((long) (buffer[6]) <<8 )  |
			  ((long) (buffer[5]) <<16)  |
			  ((long) (buffer[4]) <<24)  );


 if (resource==0)
	{
	 fcloseall();
	 puts("Sorry this file has no resource fork.");
	 return;
	}


 fseek(macfile,128+data,SEEK_SET);

 outfile=fopen(fname,"wb");
 if (outfile==NULL)
 {
  printf("Unable to create output file '%s'.\n",fname);
  return;
 }

 printf("Creating %s\n",fname);

 if (resource>511)
   for (i=0;i<(resource/512); i++)
   {
	fread(buffer,512,1,macfile);
	fwrite(buffer,512,1,outfile);
	printf(".");
   }

 if ((resource & 511)>0)
   {
	fread(buffer,(data & 511),1,macfile);
	fwrite(buffer,(data & 511),1,outfile);
   }
 puts("");


   fclose(macfile);
   if (fclose(outfile)!=0)
	{
	puts("An error occured while I tried to close this file!");
	return;
	}

   puts("Data extraction done.");


   puts("\n If you've enjoyed this utility, please send $10 to the author:\n");

   puts("                          Ray Arachelian");
   puts("                        48-21 40th Street #1B");
   puts("                        Sunnyside, N.Y. 11104");


 return;
}
